--[[
       --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


      #           #   ###########        #######           ####       #         #  ##   ###########        #           #   #   #######      ###########
      #           #   #                  #      ##       ##    ##     ##        #   ##       #             #           #   #   #      ##    #
      #           #   #                  #        #     #        #    # #       #    ##      #             #           #   #   #        #   #
      #     #     #   #                  #         #   #          #   #  ##     #            #             #     #     #   #   #      ##    #
      #     #     #   ###########        #         #   #          #   #    #    #            #             #     #     #   #   #######      ###########
       #   # #   #    #                  #         #   #          #   #     ##  #            #              #   # #   #    #   #            #
       #   # #   #    #                  #        #     #        #    #       # #            #              #   # #   #    #   #            #
        # #   # #     #                  #      ##       ##    ##     #        ##            #               # #   # #     #   #            #
         #     #      ###########        #######           ####       #         #            #                #     #      #   #            ###########


      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


                                                             ----o----(||)----o----(||)----o----

                                                                      ENHANCEMENT SHAMAN
                                                                      ~~~~~~~~~~~~~~~~~~

                                                                   v2.01 25th October 2016
                                                                  Copyright (C) Chris Birch

                                                             ----o----(||)----o----(||)----o----


               Note: This is a module for the We Don't Wipe AddOn. You need to download the latest We Don't Wipe in order to use this module
]]


--[[ ================== ]]--
--[[     Local Data     ]]-- ===============================================================================================================
--[[ ================== ]]--

local feral, doom, ignore, range, wait, uptoyou = "y", "y", "n", 0, 0.4, -34249

local playerLevel = 0
local nextPos, elapsedNextPos = 1, 0
local maelstromCurrent, maelstromMax = 0, 150
local maelstromPerGCD = 7.5
local hyRange, hyMin = false, 0
local boulderfistKnown = false
local curChargesBF, cdLeftBF, rechargeBF = 0, 1000, 1000
local hy_colour_X11Chocolate = "\124cFFD2691E"	-- HardYards chat line prefix colour
local expiresAscendance = 0
local queuedCrash, queuedFlametongue, queuedLightning = false, false, false

local GetMeleeHaste = GetMeleeHaste
local GetSpellCharges = GetSpellCharges
local GetTalentInfo = GetTalentInfo
local GetTime = GetTime
local IsSpellKnown = IsSpellKnown
local UnitLevel = UnitLevel
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax

--[[ ================ ]]--
--[[     Rotation     ]]-- =================================================================================================================
--[[ ================ ]]-- 

wdwMod_Rotations["Enhancement"] = {}
wdwMod_Rotations["Enhancement"]["Single"] = {

	["Version"] = "2.01",
	["WDW Version"] = "5.08",
	["Hard Yards Version"] = "2.07",
	["Template"] = "1.05",

	["Rotation"] = {"Setup", "GapClose", "LandslideB", "BoulderfistB", "HailstormB", "Stormstrike", "Boulderfist2", "Flametongue",
			"Sunder", "Overcharge", "Windsong", "HotHand", "Feral", "DoomWinds", "Spike", "Crash", "LavaLash", "CrashFill", 
			"BoulderFill", "RockFill", "FlameFill", "LightningFill", },
	["Parameters"] = {"DB", "List", "feral", "doom", "ignore", "range", "wait", "uptoyou" },
	["Notes"] = "Legion Patch 7.1 - Return to Karahzan",

	["feral"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "feral".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_EnhancementDB.feral or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Feral Spirit. "..
					wdw_colour_SelectiveYellow.. "Default \"y\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_EnhancementDB[ "feral" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_EnhancementDB[ "feral" ] then
			WDW_EnhancementDB[ "feral" ] = "y"
		end
		feral = WDW_EnhancementDB[ "feral" ]
	end,

	["doom"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "doom".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_EnhancementDB.doom or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Whether to include Doom Winds. "..
					wdw_colour_SelectiveYellow.. "Default \"y\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_EnhancementDB[ "doom" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_EnhancementDB[ "doom" ] then
			WDW_EnhancementDB[ "doom" ] = "y"
		end
		doom = WDW_EnhancementDB[ "doom" ]
	end,

	["ignore"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "ignore".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_EnhancementDB.ignore or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "y".. wdw_colour_Jasmine.. "/".. wdw_colour_SelectiveYellow..
					"n".. wdw_colour_Jasmine.. ". Always assume the player is within range. Ignore Hard Yards data, "..
					"and the \"overshoot\" and \"range\" parameters. "..
					wdw_colour_SelectiveYellow.. "Default \"n\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			WDW_EnhancementDB[ "ignore" ] = ( arg == "y" ) and "y" or "n"
		end
		if not WDW_EnhancementDB[ "ignore" ] then
			WDW_EnhancementDB[ "ignore" ] = "n"
		end
		ignore = WDW_EnhancementDB[ "ignore" ]
	end,

	["range"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "range".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_EnhancementDB.range or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "0".. wdw_colour_Jasmine.. " to ".. wdw_colour_SelectiveYellow..
					"20".. wdw_colour_Jasmine.. " yards. An ability must be in range so that it may appear in the "..
					"queue. If, for example, it is okay to be 5 yards outside of range then set this parameter to "..
					"\"0\". Requires the ".. hy_colour_X11Chocolate.. "Hard Yards".. wdw_colour_Jasmine.. " AddOn)" )
				return
			end
			local yards = tonumber( arg )
			WDW_EnhancementDB[ "range" ] = ( ( yards >= 0 ) and ( yards <= 20 ) ) and yards or 0
		end
		if not WDW_EnhancementDB[ "range" ] then
			WDW_EnhancementDB[ "range" ] = 0
		end
		range = WDW_EnhancementDB[ "range" ]
	end,

	["wait"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "wait".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_EnhancementDB.wait or "nil").. wdw_colour_Jasmine..
					" (".. wdw_colour_SelectiveYellow.. "0".. wdw_colour_Jasmine.. " to ".. wdw_colour_SelectiveYellow..
					"1.5".. wdw_colour_Jasmine.. " seconds. At times an ability might not be exactly ready to use as "..
					"it is cooling down or recharging. The default is to allow an ability to appear in its queue "..
					"position up to 400ms before it is ready. "..
					wdw_colour_SelectiveYellow.. "Default \"0.4\"".. wdw_colour_Jasmine.. ")" )
				return
			end
			local waitAmount = tonumber( arg )
			WDW_EnhancementDB[ "wait" ] = ( ( waitAmount >= 0 ) and ( waitAmount <= 1.5 ) ) and waitAmount or 0.4
		end
		if not WDW_EnhancementDB[ "wait" ] then
			WDW_EnhancementDB[ "wait" ] = 0.4
		end
		wait = WDW_EnhancementDB[ "wait" ]
	end,

	["uptoyou"] = function ( arg )

		if arg then
			if ( arg == "?" ) then
				print( wdw_colour_MalachiteGreen.. "uptoyou".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
					( WDW_EnhancementDB.uptoyou or "nil").. wdw_colour_Jasmine..
					" (Specify a spell or item ID obtained from www.wowhead.com. Its ICON will be used. For an ITEM "..
					"make the number negative. "..
					wdw_colour_SelectiveYellow.. "Default \"-34249\"".. wdw_colour_Jasmine.. ", the \"Hula Girl\""..
					" toy item)" )
				return
			end
			local spellItemID = tonumber( arg )
			WDW_EnhancementDB[ "uptoyou" ] = ( spellItemID ~= 0 ) and spellItemID or -34249
		end
		if not WDW_EnhancementDB[ "uptoyou" ] then
			WDW_EnhancementDB[ "uptoyou" ] = -34249					-- Hula Girl Doll
		end
		uptoyou = WDW_EnhancementDB[ "uptoyou" ]
	end,

	["DB"] = function ()

		if not WDW_EnhancementDB then WDW_EnhancementDB = {} return end
	end,

	["List"] = function ()
		print( wdw_colour_SelectiveYellow.. "Enhancement Shaman parameters:\n"..
			wdw_colour_MalachiteGreen.. "feral".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( feral or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "doom".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( doom or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "ignore".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( ignore or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "range".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( range or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "wait".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( wait or "nil" ).. wdw_colour_Jasmine.. ", ".. 
			wdw_colour_MalachiteGreen.. "uptoyou".. wdw_colour_Jasmine.. "=".. wdw_colour_SelectiveYellow..
				( uptoyou or "nil" ) ) 
	end,

	["Setup"] = function ()

		playerLevel = UnitLevel( "player" )

		nextPos, elapsedNextPos = 1, wdw_GCD

		maelstromPerGCD = 5 * ( wdw_GCDtop + wait )

-- artefact etc may be higher

		maelstromCurrent = UnitPower( "player", SPELL_POWER_MAELSTROM ) + ( 5 * wdw_GCD )	-- Assumes we are auto hitting
		maelstromMax = UnitPowerMax( "player", SPELL_POWER_MAELSTROM )
		maelstromCurrent = ( maelstromCurrent > maelstromMax ) and maelstromMax or maelstromCurrent

		expiresAscendance = wdw_buffsPlayer["114051"] and wdw_buffsPlayer["114051"].expires or 0

		if ( ignore == "y" ) then
			hyRange = true
			hyMin = 0
		else
			if ( HardYards_min ~= nil ) or ( HardYards_max ~= nil ) then
				hyRange = true
				hyMin = ( HardYards_min or 0 ) - range
				hyMin = ( hyMin < 0 ) and 0 or hyMin
			else
				hyRange = false
			end
		end

		boulderfistKnown = ( select( 4, GetTalentInfo( 1, 3, 1 ) ) == true ) and true or false
		if ( boulderfistKnown == true ) then
			local startCharges, durationCharges;
			curChargesBF, _, startCharges, durationCharges = GetSpellCharges( 201897 )
			local chargeReady = ( startCharges == 0 ) and 0 or ( startCharges + durationCharges - GetTime() )
			cdLeftBF = ( curChargesBF == 2 ) and 0 or ( ( curChargesBF == 1 ) and chargeReady or 1000 )
			-- the only place where we have to calculate our own "hastened" cool down / recharge. 6s is unhastened
			rechargeBF = 6 / ( 1 + ( GetMeleeHaste() / 100 ) )
		else
			curChargesBF, cdLeftBF, rechargeBF = 0, 1000, 1000
		end

		queuedCrash, queuedFlametongue, queuedLightning = false, false, false
	end,

	["GapClose"] = function ()	-- Feral Lunge. Tier 2 / Level 30 talent. Charge and damage. 30s cd, GCD.

		-- The Feral Lunge in game tooltip says 8 to 25 yards and that is incorrect. It is about 11.15 yards up to 25 yards
		-- The closest Hard Yards can measure, after 11.12 is 12 yards. 11.15 yards chosen here in case Hard Yards ever is able to measure

		if ( nextPos > WeDontWipeDB.queueLength ) then return end

		if ( playerLevel >= 30 ) and ( hyRange == true ) and ( hyMin  >= 11.15 ) and ( hyMin  <= 25 ) and ( expiresAscendance <= elapsedNextPos ) and ( select( 4, GetTalentInfo( 2, 2, 1 ) ) == true ) then
			local cdLeft = WeDontWipe_CooldownLeft( 196884 )
			if ( ( cdLeft - wait ) < elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 196884						-- Feral Lunge
				nextPos = nextPos + 1
				local maelstromAscendanceFL = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				maelstromCurrent = maelstromCurrent + maelstromPerGCD + maelstromAscendanceFL
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				hyMin = 0
				return
			end
		end

		if ( hyRange == true ) and ( hyMin  >= 20 ) then
			if ( playerLevel >= 80 ) and ( ( expiresAscendance <= elapsedNextPos ) or ( ( expiresAscendance > elapsedNextPos ) and ( hyMin  > 30 ) ) ) then
				local cdLeftSW1 = WeDontWipe_CooldownLeft( 58875 )
				if ( ( cdLeftSW1 - wait ) < elapsedNextPos ) then
					wdw_Queue[ nextPos ] = 58875						-- Spirit Walk. 60s cd, GCD. 8s up time
					nextPos = nextPos + 1
					local maelstromAscendanceSW = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
					maelstromCurrent = maelstromCurrent + maelstromPerGCD + maelstromAscendanceSW
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				end
			end
			if ( hyMin  <= 40 ) and ( queuedLightning == false ) and ( ( expiresAscendance <= elapsedNextPos ) or ( ( expiresAscendance > elapsedNextPos ) and ( hyMin  > 30 ) ) ) then
				wdw_Queue[ nextPos ] = 187837
				nextPos = nextPos + 1
				local maelstromAscendanceLB = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				maelstromCurrent = maelstromCurrent + maelstromPerGCD + maelstromAscendanceLB
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				queuedLightning = true
			end
			return
		end
	end,

	["LandslideB"] = function ()	-- Landslide Tier 7 / Level 100 talent 197992. Passive 10s damage buff 202004 added to Rockbiter / Boulderfist
					-- Strange... Wowhead says Landslide passive has 0 GCD but the buff has a 1.5s GCD ???
					-- Rockbiter 193786. Level 10. 10 yards. GCD. PLUS 15 Maelstrom
					-- Boulderfist 201897. Level 15 talent. Replaces Rockbiter. 10 yards. GCD. 2 charges, 6s recharge. Buff 218825 lasts 10s. PLUS 25 Maelstrom

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 100 ) or ( boulderfistKnown == true ) or ( hyRange == false ) or ( hyMin  >= 12 ) or ( select( 4, GetTalentInfo( 7, 2, 1 ) ) == false ) then return end

		local expiresLandslide = wdw_buffsPlayer["202004"] and wdw_buffsPlayer["202004"].expires or -2
		if ( expiresLandslide >= elapsedNextPos ) then return end

		if ( boulderfistKnown == false ) then
			wdw_Queue[ nextPos ] = 193786
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + 15 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		elseif ( ( cdLeftBF - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 201897
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + 25 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			curChargesBF = curChargesBF - 1
			cdLeftBF = ( curChargesBF == 0 ) and rechargeBF or 0
		end
	end,

	["BoulderfistB"] = function ()	-- Boulderfist 201897. Level 15 talent. Replaces Rockbiter. 10 yards. GCD. 2 charges, 6s recharge. Buff 218825 lasts 10s. PLUS 25 Maelstrom
					-- Strictly the buff here. If we cap maelstrom then so be it
					-- Note, Landslide buff gets applied concurrently thus, if Boulderfst is known we don't need to do the LandslideB function (above)

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 15 ) or ( hyRange == false ) or ( hyMin  >= 12 ) or ( boulderfistKnown == false ) then return end

		local expiresBoulderfist = wdw_buffsPlayer["218825"] and wdw_buffsPlayer["218825"].expires or 0
		if ( expiresBoulderfist > elapsedNextPos ) then return end

		if ( ( cdLeftBF - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 201897
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + 25 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			curChargesBF = curChargesBF - 1
			cdLeftBF = ( curChargesBF == 0 ) and rechargeBF or 0
		end
	end,

	["HailstormB"] = function ()	-- Hailstorm BUFF. Tier 4 / Level 60 talent. Passive damage buff added to Frostbrand
					-- Frostbrand 196834. Level 19 ability. GCD, 16s buff duration, 20 Maelstrom cost
					-- Can refresh with < 4.5s remaining and remaining time will be carried over

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 60 ) or ( hyRange == false ) or ( hyMin  >= 12 ) or ( select( 4, GetTalentInfo( 4, 3, 1 ) ) == false ) then return end

		local expiresHailstorm = wdw_buffsPlayer["196834"] and wdw_buffsPlayer["196834"].expires or -2

		if ( ( expiresHailstorm - 4.5 ) < elapsedNextPos ) then
			if ( maelstromCurrent >= 20 ) then
				wdw_Queue[ nextPos ] = 196834
				nextPos = nextPos + 1
				local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				maelstromCurrent = maelstromCurrent - 20 + maelstromPerGCD + maelstromAscendance
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				return
			end
		end

		-- To here if wasn't able to refresh due to lack of Maelstrom. Might be able to wait a bit. Test if need to force the issue

		if ( ( expiresHailstorm - wait - wdw_GCDtop ) < elapsedNextPos ) then
			if ( boulderfistKnown == false ) then
				-- Maelstrom generated is 15 plus some from the GCD after Rockbiter and the delay in button pressing. Easily gets to 20
				wdw_Queue[ nextPos ] = 193786
				nextPos = nextPos + 1
				local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				maelstromCurrent = maelstromCurrent + 15 + maelstromPerGCD + maelstromAscendance
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
			elseif ( ( cdLeftBF - wait ) < elapsedNextPos ) then
				wdw_Queue[ nextPos ] = 201897
				nextPos = nextPos + 1
				local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				maelstromCurrent = maelstromCurrent + 25 + maelstromPerGCD + maelstromAscendance
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				curChargesBF = curChargesBF - 1
				cdLeftBF = ( curChargesBF == 0 ) and rechargeBF or 0
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
			else
				return
			end
			wdw_Queue[ nextPos ] = 196834
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent - 20 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,

	["Stormstrike"] = function ()	-- Stormstrike 17364. Level 26. 16s cd, GCD, melee, COST 40 maelstrom
					-- Stormbringer 201846 buff. 5% chance from SS. Cost halved, 12s buff, reset SS cd AND next SS has no cd (but costs 40M)
					-- For simplicity, Ascendance maelstrom calculation ignores "wait" parameter throughout this module but only here would it have a (slight) noticeable impact

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 20 ) or ( hyRange == false ) or ( ( expiresAscendance <= elapsedNextPos ) and ( hyMin  > 5 ) ) or ( ( expiresAscendance > elapsedNextPos ) and ( hyMin  > 30 ) ) then return end

		local expiresStormbringer = wdw_buffsPlayer["201846"] and ( wdw_buffsPlayer["201846"].expires ) or -2

		if ( expiresStormbringer > elapsedNextPos ) then
			if ( maelstromCurrent >= 20 ) then
				wdw_Queue[ nextPos ] = 17364
				nextPos = nextPos + 1
				local maelstromAscendanceSB1 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				maelstromCurrent = maelstromCurrent - 20 + maelstromPerGCD + maelstromAscendanceSB1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
			elseif ( ( expiresStormbringer - wait - wdw_GCDtop ) > elapsedNextPos ) then
				if ( boulderfistKnown == false ) and ( hyMin  < 12 ) then				-- Rockbiter
					-- Maelstrom generated is 15 plus some from the GCD after Rockbiter and the delay in button pressing and Ascendance. Easily gets to 20
					wdw_Queue[ nextPos ] = 193786
					nextPos = nextPos + 1
					local maelstromAscendanceSB2 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
					maelstromCurrent = maelstromCurrent + 15 + maelstromPerGCD + maelstromAscendanceSB2
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				elseif ( ( cdLeftBF - wait ) < elapsedNextPos ) and ( hyMin  < 12 ) then
					wdw_Queue[ nextPos ] = 201897
					nextPos = nextPos + 1
					local maelstromAscendanceSB3 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
					maelstromCurrent = maelstromCurrent + 25 + maelstromPerGCD + maelstromAscendanceSB3
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					curChargesBF = curChargesBF - 1
					cdLeftBF = ( curChargesBF == 0 ) and rechargeBF or 0
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				else
					return
				end
				wdw_Queue[ nextPos ] = 17364
				nextPos = nextPos + 1
				local maelstromAscendanceSB4 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				maelstromCurrent = maelstromCurrent - 20 + maelstromPerGCD + maelstromAscendanceSB4
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
			end
		end

		-- To here with a Stormbringer consumed. If talented to Tempest, player might have two Stormbringers
		-- Count suffices, no need to check for talent

		if ( expiresStormbringer > elapsedNextPos ) and ( wdw_buffsPlayer["201846"].count == 2 ) then
			if ( maelstromCurrent >= 20 ) then
				wdw_Queue[ nextPos ] = 17364
				nextPos = nextPos + 1
				local maelstromAscendanceSB5 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				maelstromCurrent = maelstromCurrent - 20 + maelstromPerGCD + maelstromAscendanceSB5
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
			elseif ( ( expiresStormbringer - wait - wdw_GCDtop ) > elapsedNextPos ) then
				if ( boulderfistKnown == false ) and ( hyMin  < 12 ) then
					-- Maelstrom generated is 15 plus some from the GCD after Rockbiter and the delay in button pressing and Ascendance. Easily gets to 20
					wdw_Queue[ nextPos ] = 193786
					nextPos = nextPos + 1
					local maelstromAscendanceSB6 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
					maelstromCurrent = maelstromCurrent + 15 + maelstromPerGCD + maelstromAscendanceSB6
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				elseif ( ( cdLeftBF - wait ) < elapsedNextPos ) and ( hyMin  < 12 ) then
					wdw_Queue[ nextPos ] = 201897
					nextPos = nextPos + 1
					local maelstromAscendanceSB7 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
					maelstromCurrent = maelstromCurrent + 25 + maelstromPerGCD + maelstromAscendanceSB7
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					curChargesBF = curChargesBF - 1
					cdLeftBF = ( curChargesBF == 0 ) and rechargeBF or 0
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
				else
					return
				end
				wdw_Queue[ nextPos ] = 17364
				nextPos = nextPos + 1
				local maelstromAscendanceSB8 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				maelstromCurrent = maelstromCurrent - 20 + maelstromPerGCD + maelstromAscendanceSB8
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				if ( nextPos > WeDontWipeDB.queueLength ) then return end
			end
		end

		local cdLeft = WeDontWipe_CooldownLeft( 17364 )

		if ( ( cdLeft - wait ) < elapsedNextPos ) then
			if ( maelstromCurrent >= 40 ) then
				wdw_Queue[ nextPos ] = 17364
				nextPos = nextPos + 1
				local maelstromAscendanceSS1 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				maelstromCurrent = maelstromCurrent - 40 + maelstromPerGCD + maelstromAscendanceSS1
				elapsedNextPos = elapsedNextPos + wdw_GCDtop
				return
			end
		end

		if ( ( cdLeft - wait - wdw_GCDtop ) < elapsedNextPos ) and ( hyMin  < 12 ) then
			-- Asking the question: By the time we get around to doing a SS, will there be sufficient maelstrom after having done a RB or a BF?
			if ( boulderfistKnown == false ) then
				local maelstromAscendanceRB1 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				if ( maelstromCurrent >= ( 40 - 15 - maelstromPerGCD - maelstromAscendanceRB1 ) ) then
					wdw_Queue[ nextPos ] = 193786
					nextPos = nextPos + 1
					maelstromCurrent = maelstromCurrent + 15 + maelstromPerGCD + maelstromAscendanceRB1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
					wdw_Queue[ nextPos ] = 17364
					nextPos = nextPos + 1
					maelstromAscendanceRB1 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
					maelstromCurrent = maelstromCurrent - 40 + maelstromPerGCD + maelstromAscendanceRB1
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					return
				end
			elseif ( ( cdLeftBF - wait ) < elapsedNextPos ) then
				local maelstromAscendanceBF = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
				if ( maelstromCurrent >= ( 40 - 25 - maelstromPerGCD - maelstromAscendanceBF ) ) then
					wdw_Queue[ nextPos ] = 201897
					nextPos = nextPos + 1
					maelstromCurrent = maelstromCurrent + 25 + maelstromPerGCD + maelstromAscendanceBF
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					curChargesBF = curChargesBF - 1
					cdLeftBF = ( curChargesBF == 0 ) and rechargeBF or 0
					if ( nextPos > WeDontWipeDB.queueLength ) then return end
					wdw_Queue[ nextPos ] = 17364
					nextPos = nextPos + 1
					maelstromAscendanceBF = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
					maelstromCurrent = maelstromCurrent - 40 + maelstromPerGCD + maelstromAscendanceBF
					elapsedNextPos = elapsedNextPos + wdw_GCDtop
					return
				end
			end
		end

		if ( boulderfistKnown == false ) and ( ( cdLeft - wait - wdw_GCDtop - wait - wdw_GCDtop ) < elapsedNextPos ) and ( hyMin  < 12 ) then
			-- maelstrom calculation is maelstromCurrent >= ( 40 - 15 - maelstromPerGCD - 15 - maelstromPerGCD - maelstromAscendance - maelstromAscendance )
			-- Without Ascendance it is over 40 anyhow
			wdw_Queue[ nextPos ] = 193786
			nextPos = nextPos + 1
			local maelstromAscendanceRB2 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + 15 + maelstromPerGCD + maelstromAscendanceRB2
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
			wdw_Queue[ nextPos ] = 193786
			nextPos = nextPos + 1
			maelstromAscendanceRB2 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + 15 + maelstromPerGCD + maelstromAscendanceRB2
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			if ( nextPos > WeDontWipeDB.queueLength ) then return end
			wdw_Queue[ nextPos ] = 17364
			nextPos = nextPos + 1
			maelstromAscendanceRB2 = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent - 40 + maelstromPerGCD + maelstromAscendanceRB2
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,

	["Boulderfist2"] = function ()	-- Boulderfist 201897. Level 15 talent. Replaces Rockbiter. 10 yards. GCD. 2 charges, 6s recharge. Buff 218825 lasts 10s. PLUS 25 Maelstrom

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 15 ) or ( hyRange == false ) or ( hyMin  > 10 ) or ( maelstromCurrent > 120 ) or ( boulderfistKnown == false ) then return end
		-- Icy Veins says 130 but I suspect they are in error. 130 + 25 + 7.5/9 will easily exceed the cap of 150. Note I also allow here for the GCD - another 1.5s of Maelstrom generation

		if ( curChargesBF == 2 ) or ( ( curChargesBF == 1 ) and ( ( cdLeftBF - wait ) < elapsedNextPos ) ) then
			wdw_Queue[ nextPos ] = 201897
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + 25 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			curChargesBF = curChargesBF - 1
			cdLeftBF = ( curChargesBF == 0 ) and rechargeBF or 0
		end
	end,

	["Flametongue"] = function ()	-- Flametongue BUFF 194084. Level 12 193796. 16s duration. 12s cd, GCD
					-- Can refresh with < 4.5s remaining and remaining time will be carried over

		if ( nextPos > WeDontWipeDB.queueLength ) or ( queuedFlametongue == true ) or ( playerLevel < 12 ) or ( hyRange == false ) or ( hyMin  > 10 ) then return end

		local expiresFlametongue = wdw_buffsPlayer["194084"] and wdw_buffsPlayer["194084"].expires or 0

		if ( ( expiresFlametongue - 4.5 ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 193796
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			queuedFlametongue = true
		end
	end,

	["Sunder"] = function ()	-- Sundering 197214. Tier 6 / Level 90 talent. 40s cd, GCD. 2s duration. COSTS 60 Maelstrom.
					-- Range undocumented but appears to be a bit more than 11.5 yards. Certainly less than 12 yards

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 90 ) or ( hyRange == false ) or ( hyMin  > 11.5 ) or ( maelstromCurrent < 95 ) or ( select( 4, GetTalentInfo( 6, 3, 1 ) ) == false ) then return end
		-- Not on Icy Veins. Keep 35 maelstrom in reserve for SS procs

		local cdLeft = WeDontWipe_CooldownLeft( 197214 )
		if ( ( cdLeft - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 197214
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent - 60 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,

	["Overcharge"] = function ()	-- Overcharge Tier 5 / Level 45 talent. Alters Lightning Bolt 187837. Now: COST 45 Maelstrom, 9s cd, GCD, no swing timer penalty

		if ( nextPos > WeDontWipeDB.queueLength ) or ( queuedLightning == true ) or ( playerLevel < 45 ) or ( hyRange == false ) or ( hyMin  > 40 ) or ( maelstromCurrent < 80 ) or ( select( 4, GetTalentInfo( 5, 2, 1 ) ) == false ) then return end
		-- Not on Icy Veins. Keep 35 maelstrom in reserve for SS procs

		cdLeft = WeDontWipe_CooldownLeft( 187837 )
		if ( ( cdLeft - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 187837
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent - 45 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			queuedLightning = true
		end
	end,

	["Windsong"] = function ()	-- Windsong 201898 Tier 1 / Level 15 talent. 45s cd, GCD. 10 yards. Buff lasts 20s

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 15 ) or ( hyRange == false ) or ( hyMin  > 10 ) or ( select( 4, GetTalentInfo( 1, 1, 1 ) ) == false ) then return end
		-- Not on Icy Veins

		cdLeft = WeDontWipe_CooldownLeft( 201898 )
		if ( ( cdLeft - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 201898
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,

	["HotHand"] = function ()	-- Hot Hand Tier 1 / Level 15 talent. Buffs 215785 Lava Lash. Now: COST FREE Maelstrom, double damage. Buff 15s duration

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 15 ) or ( hyRange == false ) or ( hyMin  > 5 ) or ( select( 4, GetTalentInfo( 1, 2, 1 ) ) == false ) then return end
		-- Not on Icy Veins

		local expiresHotHand = wdw_buffsPlayer["215785"] and wdw_buffsPlayer["215785"].expires or 0

		if ( expiresHotHand > elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 60103
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,

	["Feral"] = function ()	-- Feral Spirit 51533. Level 36. 120s cd, GCD, 15s duration, 30 yards (i.e. no target and they are wasted). NO threat/engage of target!

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 36 ) or ( hyRange == false ) or ( hyMin  > 30 ) or ( feral == "n" ) then return end

		cdLeft = WeDontWipe_CooldownLeft( 51533 )
		if ( ( cdLeft - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 51533
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,

	["DoomWinds"] = function ()	-- Doom Winds 204945. Artefact. 60s cd, GCD, 6s duration. Guarantees Windfury procs + double damage on auto attacks. i.e. must be in melee range

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 98 ) or ( hyRange == false ) or ( hyMin  > 5 ) or ( IsSpellKnown( 204945 ) == false ) or ( doom == "n" ) then return end

		local cdLeft = WeDontWipe_CooldownLeft( 204945 )
		if ( ( cdLeft - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 204945
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,

	["Spike"] = function ()	-- Earthen Spike. Tier 7 / level 100 talent. 20s cd, GCD. 10s up. 10 yard range. COST 30 Maelstrom

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 100 ) or ( hyRange == false ) or ( hyMin  > 10 ) or ( maelstromCurrent < 65 ) or ( select( 4, GetTalentInfo( 7, 3, 1 ) ) == false ) then return end
		-- Not on Icy Veins. Keep 35 maelstrom in reserve for SS procs

		local cdLeft = WeDontWipe_CooldownLeft( 188089 )
		if ( ( cdLeft - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 188089
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent - 30 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,

	["Crash"] = function ()	-- Crash Lightning 187874. Level 28. 6s cd, GCD. melee, with additional damage to 8 yards frontal cone VIA 10s buff for SS and LL. COSTS 20 Maelstrom
				-- Requires Crashing Storm, Tier 6 / level 90 talent. Passive. Very close range AoE DoT. 4 yards?
				-- The 10s buff maintenance is ignored over using Crash Lightning on cd

		if ( nextPos > WeDontWipeDB.queueLength ) or ( queuedCrash == true ) or ( playerLevel < 28 ) or ( hyRange == false ) or ( hyMin  > 5 ) or ( maelstromCurrent < 20 ) or ( select( 4, GetTalentInfo( 6, 1, 1 ) ) == false ) then return end
		-- Icy Veins doesn't have a maelstrom requirement. Elsewhere >80M. 20 seems about right to me

		local cdLeft = WeDontWipe_CooldownLeft( 187874 )
		if ( ( cdLeft - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 187874
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent - 20 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			queuedCrash = true
		end
	end,

	["LavaLash"] = function ()	-- Lava Lash 60103. Level 10. GCD, Melee, COST 30 Maelstrom

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 10 ) or ( hyRange == false ) or ( hyMin  > 5 ) or ( maelstromCurrent < 65 ) then return end
		-- Icy Veins says 110m. I'm going with 35 maelstrom in reserve for SS procs

		wdw_Queue[ nextPos ] = 60103
		nextPos = nextPos + 1
		local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
		maelstromCurrent = maelstromCurrent - 30 + maelstromPerGCD + maelstromAscendance
		elapsedNextPos = elapsedNextPos + wdw_GCDtop
	end,

	["CrashFill"] = function ()	-- Crash Lightning 187874. Level 28. 6s cd, GCD. melee, with additional damage to 8 yards frontal cone VIA 10s buff for SS and LL. COSTS 20 Maelstrom
					-- The 10s buff maintenance is ignored over using Crash Lightning on cd

		if ( nextPos > WeDontWipeDB.queueLength ) or ( queuedCrash == true ) or ( playerLevel < 28 ) or ( hyRange == false ) or ( hyMin  > 5 ) or ( maelstromCurrent < 55 ) then return end

		local cdLeft = WeDontWipe_CooldownLeft( 187874 )
		if ( ( cdLeft - wait ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 187874
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent - 20 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			queuedCrash = true
		end
	end,

	["BoulderFill"] = function ()	-- Boulderfist 201897. Level 15 talent. Replaces Rockbiter. 10 yards. GCD. 2 charges, 6s recharge. Buff 218825 lasts 10s. PLUS 25 Maelstrom

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 15 ) or ( hyRange == false ) or ( hyMin  > 10 ) or ( maelstromCurrent < 50 ) or ( boulderfistKnown == false ) then return end

		if ( curChargesBF >= 1 ) or ( ( curChargesBF == 0 ) and ( ( cdLeftBF - wait ) < elapsedNextPos ) ) then
			wdw_Queue[ nextPos ] = 201897
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + 25 + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,

	["RockFill"] = function ()	-- Rockbiter. Level 12 193786. GCD

		if ( nextPos > WeDontWipeDB.queueLength ) or ( playerLevel < 10 ) or ( hyRange == false ) or ( hyMin  > 10 ) or ( boulderfistKnown == true ) then return end

		for i = nextPos, WeDontWipeDB.queueLength do
			wdw_Queue[ i ] = 193786
		end
		nextPos = WeDontWipeDB.queueLength + 1
	end,

	["FlameFill"] = function ()	-- Flametongue. Level 12 193796. 16s duration. 12s cd, GCD
					-- Can refresh with < 4.5s remaining and remaining time will be carried over

		if ( nextPos > WeDontWipeDB.queueLength ) or ( queuedFlametongue == true ) or ( playerLevel < 12 ) or ( hyRange == false ) or ( hyMin  > 10 ) then return end

		local cdLeft = WeDontWipe_CooldownLeft( 193796 )
		if ( ( cdLeft - 4.5 ) < elapsedNextPos ) then
			wdw_Queue[ nextPos ] = 193796
			nextPos = nextPos + 1
			local maelstromAscendance = ( expiresAscendance <= elapsedNextPos ) and 0 or ( ( expiresAscendance > ( elapsedNextPos + wdw_GCDtop ) ) and ( 10 * wdw_GCDtop ) or ( 10 * ( expiresAscendance - elapsedNextPos ) ) )
			maelstromCurrent = maelstromCurrent + maelstromPerGCD + maelstromAscendance
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
			queuedFlametongue = true
		end
	end,

	["LightningFill"] = function ()	-- Lightning Bolt. Level 1 187837. 40 yards. GCD

		if ( nextPos > WeDontWipeDB.queueLength ) then return end

		if ( queuedLightning == true ) or ( ( hyRange == true ) and ( hyMin  <= 10 ) ) then
			-- Way to close to even sneak in one LB as doing so resets the swing timer = lose an auto attack
			for i = nextPos, WeDontWipeDB.queueLength do
				wdw_Queue[ i ] = uptoyou
			end
			return
		end

		for i = nextPos, WeDontWipeDB.queueLength do
			if ( hyRange == true ) and ( hyMin  <= 40 ) and ( queuedLightning == false ) and ( select( 4, GetTalentInfo( 5, 2, 1 ) ) == true ) then	-- Overcharge talent
				local cdLeft = WeDontWipe_CooldownLeft( 187837 )
				if ( ( cdLeft - wait ) < elapsedNextPos ) then
					wdw_Queue[ i ] = 187837
					queuedLightning = true
				end
			elseif ( expiresAscendance > elapsedNextPos ) and ( hyRange == true ) and ( hyMin  <= 30 ) then
				-- We can auto attack from this range
				wdw_Queue[ i ] = uptoyou
			elseif ( queuedLightning == false ) and ( hyRange == true ) and ( hyMin  <= 40 ) then
				wdw_Queue[ i ] = 187837
			else
				wdw_Queue[ i ] = uptoyou
			end
			elapsedNextPos = elapsedNextPos + wdw_GCDtop
		end
	end,
}